protected/controllers/InfluencerController.php
<?php

class InfluencerController extends Controller
{
	/**
	 * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
	 * using two-column layout. See 'protected/views/layouts/column2.php'.
	 */
	public $layout='//layouts/column2';

	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
			'accessControl', // perform access control for CRUD operations
		);
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
			array('allow', // allow authenticated user to perform 'create' and 'update' actions
				'actions'=>array('index', 'view', 'create','update','delete', 'seeds', 'export'),
				'users'=>array('@'),
			),
			array('deny',  // deny all users
				'users'=>array('*'),
			),
		);
	}

	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{	
		$this->render('view',array(
			'model'=>$this->loadModel($id),
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate()
	{
		$model = new Influencer;

		if (isset($_POST['Influencer']))
		{
			$model->attributes = array_map('trim', $_POST['Influencer']);
			$model->added_by_user_id = Yii::app()->user->info->id;

			if ($model->validate())
			{
				if ($this->additionalFormValidation($model))
				{
					if ($model->save())
					{
						Yii::app()->user->setFlash('success', 'Item successfully created!');
						$this->redirect(array('view','id'=>$model->id));
					}
					else 
						Yii::app()->user->setFlash('error', 'Unable to save record!');
				}
			}
		}

		$this->render('create',array(
			'model'=>$model,
		));
	}

	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionUpdate($id)
	{
		$model=$this->loadModel($id);

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['Influencer']))
		{
			$model->attributes = array_map('trim', $_POST['Influencer']);
			if($model->save())
			{
				Yii::app()->user->setFlash('success', 'Item successfully updated.');
				$this->redirect(array('view','id'=>$model->id));
			}
		}

		$this->render('update',array(
			'model'=>$model,
		));
	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDelete($id)
	{
		$model = $this->loadModel($id);

		$model->status = Influencer::STATUS_DELETED;

		if ($model->save())
		{
			Yii::app()->user->setFlash('success', 'Item successfully delete.');
			$this->redirect(['index']);
		}
	}

	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
		$model = new Influencer;

		$filterParams = $this->prepareFilterParams();
		$queryAdditionalCond = $this->prepareAdditionalCond($filterParams);

		$query = '
			SELECT infl.*, user.username FROM {{influencer}} AS infl
			INNER JOIN {{user}} AS user ON user.id = infl.added_by_user_id
			WHERE 1
			'. $queryAdditionalCond .'
			AND infl.status = '. Influencer::STATUS_ACTIVE .'
			ORDER BY infl.id DESC
		';

		$command = Yii::app()->db->createCommand($query);
		$influencers = $command->queryAll();

		$influencersDP = new CArrayDataProvider($influencers);
		$influencersDP->getPagination()->pageSize = 100;

		$this->render('index',array(
			'model' => $model,
			'filterParams' => $filterParams,
			'influencersDP'=>$influencersDP,
		));
	}

	public function actionExport() 
	{
		header('Content-Type: application/csv');
		header('Content-Disposition: attachment; filename="InfluencerExport.csv";');

		$filterParams = $this->prepareFilterParams();
		$queryAdditionalCond = $this->prepareAdditionalCond($filterParams);

		$query = '
			SELECT infl.*, user.username FROM {{influencer}} AS infl
			INNER JOIN {{user}} AS user ON user.id = infl.added_by_user_id
			WHERE 1
			'. $queryAdditionalCond .'
			AND infl.status = '. Influencer::STATUS_ACTIVE .'
			ORDER BY infl.id DESC
		';

		$command = Yii::app()->db->createCommand($query);
		$influencers = $command->queryAll();

		$influencersDP = new CArrayDataProvider($influencers);
		$influencersDP->getPagination()->pageSize = $influencersDP->totalItemCount;

		$exportColumns = [
			'Date Created',
			'Added By',
			'Full Name',
			'Seeding Plaform',
			'Followers',
			'TikTok Handle',
			'Instgram Handle',	
			'Youtube Handle',
			'Following Tier',	
			'Demographic',
			'Segment',
			'Notes'
		];

		$exportRows = [];

		$exportRows[] = $exportColumns;
		if (count($influencersDP->rawData) > 0) {
			foreach ($influencersDP->rawData as $data) {
				$dateCreated = date('Y-m-d', strtotime('now')) . ' @ ' . date('h:m A', strtotime('now'));
				$fullName = $data['first_name'] . ' ' . $data['last_name'];

				$exportRows[] = [
					$dateCreated,
					$data['username'], // Added By
					$fullName, // Full Name
					Influencer::getSeedingPlatformLabel($data['seeding_platform']), // Seeding Plaform
					$data['followers'], // Followers
					$data['handle_tiktok'], // TikTok Handle
					$data['handle_instagram'], // Instgram Handle
					$data['handle_youtube'], // Youtube Handle
					Influencer::getFollowingTierLabel($data['following_tier']), // Tier
					Influencer::getDemographicLabel($data['demographic']), // Demographic
					Influencer::getSegmentLabel($data['segment']), // Segment
					$data['notes'], // Notes
				];
			}
		}
		
		// Open a file in write mode ('w')
		// $fp = fopen('export/influencerExportData-'.date('Y-m-d').'.csv', 'w+');
		
		$fp = fopen('php://output', 'w');

		// Loop through file pointer and a line
		foreach ($exportRows as $fields) {
			fputcsv($fp, $fields);
		}
		
		fclose($fp);
	}

	/**
	 * Manages all models.
	 */
	public function actionAdmin()
	{
		$model=new Influencer('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['Influencer']))
			$model->attributes=$_GET['Influencer'];

		$this->render('admin',array(
			'model'=>$model,
		));
	}

	/**
	 * Seeds data
	 */
	public function actionSeeds($key)
	{
		if ($key != '86f7e437')
			throw new CHttpException(403, 'Forbidden to access the page!');
		
		$itemCount = 20;
		for ($i = 0; $itemCount > $i; $i++) {
			$model = new Influencer;

			$model->first_name = 'Jonh';
			$model->last_name = 'Duh';
			$model->seeding_platform = Influencer::SEEDING_PLATFORM_YOUTUBE;
			$model->followers = 1000;
			$model->handle_tiktok = 'JohnDuTk';
			$model->handle_instagram = 'JohnDuIns';
			$model->handle_youtube = 'JohnDuYT';
			$model->hyperlink_tiktok = 'https://www.google.com/';
			$model->hyperlink_instagram = 'https://www.google.com/';
			$model->hyperlink_youtube = 'https://www.google.com/';
			$model->following_tier = Influencer::FOLLOWING_TIER_MICRO;
			$model->demographic = Influencer::DEMOGRAPHIC_GENZ;
			$model->segment = Influencer::SEGMENT_SKINFLUENCER;
			$model->notes = 'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do';
			$model->added_by_user_id = 25;
			
			$model->save(false);
		}

		echo 'Success! - '.strtotime('now');
	}

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer $id the ID of the model to be loaded
	 * @return Influencer the loaded model
	 * @throws CHttpException
	 */
	public function loadModel($id)
	{
		$model=Influencer::model()->findByPk($id);
		if($model===null)
			throw new CHttpException(404,'The requested page does not exist.');
		return $model;
	}

	/**
	 * Performs the AJAX validation.
	 * @param Influencer $model the model to be validated
	 */
	protected function performAjaxValidation($model)
	{
		if(isset($_POST['ajax']) && $_POST['ajax']==='influencer-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}
	}

	protected function prepareAdditionalCond($filterParams) 
	{
		$cond = '';

		if ($filterParams['date_created_from'] != '' && $filterParams['date_created_to'] != '')
			$cond .= ' AND DATE(infl.date_created) BETWEEN "'. $filterParams['date_created_from'] .'" AND "'. $filterParams['date_created_to'] .'"';

		if ($filterParams['full_name'] != '')
			$cond .= ' AND CONCAT(infl.first_name, " ", infl.last_name) LIKE "%'. $filterParams['full_name'] .'%"';

		if ($filterParams['added_by_user_id'] != '')
			$cond .= ' AND infl.added_by_user_id = ' . $filterParams['added_by_user_id'];			
			
		if (!empty($_GET['seeding_platform']))
			$cond .= ' AND infl.seeding_platform = ' . $filterParams['seeding_platform'];

		if (!empty($_GET['followers']))
			$cond .= ' AND infl.followers < ' . $filterParams['followers'];

		if (!empty($_GET['handle_tiktok']))
			$cond .= ' AND infl.handle_tiktok like "%' . $filterParams['handle_tiktok'] . '%"';

		if (!empty($_GET['handle_instagram']))
			$cond .= ' AND infl.handle_instagram like "%' . $filterParams['handle_instagram'] . '%"';

		if (!empty($_GET['handle_youtube']))
			$cond .= ' AND infl.handle_youtube like "%' . $filterParams['handle_youtube'] . '%"';

		if (!empty($_GET['following_tier']))
			$cond .= ' AND infl.following_tier like "%' . $filterParams['following_tier'] . '%"';

		if (!empty($_GET['demographic']))
			$cond .= ' AND infl.demographic = ' . $filterParams['demographic'];


protected/views/layouts/column1.php
<?php /* @var $this Controller */ ?>
<?php $this->beginContent('//layouts/main'); ?>
<div id="content">
	<?php echo $content; ?>
</div><!-- content -->
<?php $this->endContent(); ?>

protected/views/layouts/column2.php
<?php /* @var $this Controller */ ?>
<?php $this->beginContent('//layouts/main'); ?>
<div class="span-19">
	<div id="content">
		<?php echo $content; ?>
	</div><!-- content -->
</div>
<div class="span-5 last">
	<div id="sidebar">
	<?php
		$this->beginWidget('zii.widgets.CPortlet', array(
			'title'=>'Operations',
		));
		$this->widget('zii.widgets.CMenu', array(
			'items'=>$this->menu,
			'htmlOptions'=>array('class'=>'operations'),
		));
		$this->endWidget();
	?>
	</div><!-- sidebar -->
</div>
<?php $this->endContent(); ?>

protected/views/layouts/main.php
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
    <meta name="description" content="">
    <meta name="author" content="">
    <link rel="icon" href="../../favicon.ico">

    <title>Influencer Marketing App</title>

    <!-- Bootstrap core CSS -->
    <link href="<?php echo Yii::app()->request->baseUrl; ?>/css/bootstrap/bootstrap.min.css" rel="stylesheet">

    <!-- Custom styles for this template -->
    <link href="<?php echo Yii::app()->request->baseUrl; ?>/css/navbar-fixed-top.css?v=1" rel="stylesheet">

    <!-- Custom styles for this template -->
    <link href="<?php echo Yii::app()->request->baseUrl; ?>/css/form.css?v=1" rel="stylesheet">

    <style>
      body {background: #f5f5f5 !important;}
    </style>
  </head>

  <body>

    <!-- Fixed navbar -->
    <nav class="navbar navbar-inverse navbar-fixed-top">
      <div class="container">
        <div class="navbar-header">
          <a class="navbar-brand" href="#">Influencer Marketing App</a>
        </div>
        <div id="navbar" class="navbar-collapse collapse">
          <?php if (!Yii::app()->user->isGuest) : ?>
            <ul class="nav navbar-nav">
              <li><?php echo CHtml::link('Manage', ['influencer/index']); ?></li>
              <li><?php echo CHtml::link('Create', ['influencer/create']); ?></li>
            </ul>
            <ul class="nav navbar-nav navbar-right">
              <li><?php echo CHtml::link('Logout ('. Yii::app()->user->name .')', ['/site/logout']); ?></li>
            </ul>
          <?php else: ?>
            <ul class="nav navbar-nav navbar-right">
              <li><?php echo CHtml::link('Login', ['/site/login']); ?></li>
            </ul>
          <?php endif; ?>
        </div><!--/.nav-collapse -->
      </div>
    </nav>

	<?php echo $content; ?>

    <!-- Bootstrap core JavaScript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
    <script>window.jQuery || document.write('<script src="../../assets/js/vendor/jquery.min.js"><\/script>')</script>
    <script src="<?php echo Yii::app()->request->baseUrl; ?>/js/bootstrap/bootstrap.min.js"></script>
  </body>
</html>